README file for Commerce Merchant Warrior

## CONTENTS OF THIS FILE

- Introduction
- Requirements
- Installation
- Configuration
- How It Works

## INTRODUCTION

This project integrates Merchant Warrior payments into the Drupal Commerce
payment and checkout systems.

With the integration of Merchant Warrior payments into Drupal Commerce, you can
provide a seamless and secure payment experience for your customers.

### Features

- This module provides a REST endpoint for decoupled architectures to process an
authorization via the Merchant Warrior Payframe payment solution.

- In addition, the module supports Merchant Warrior's Token Payments feature.
This allows you to securely store customer credit card information in the
Merchant Warrior system and authorize payments in the Drupal Backend without
handling sensitive card data directly.

#### Using REST

- Make a call to `/api/merchant-warrior/get-access-token` to fetch an access
token
  - It will also include the Payframe submit url and Payframe src url needed for
the FE (depending on whether we're in `test` mode or not)
- Use the token in the FE to load the Payframe Iframe into the FE as shown here:
`https://jsfiddle.net/merchantwarrior/n7zfhb8k/2/`
  - Once the credit card details are entered, the FE will make a call to the
`getPayframeToken` API
- Payframe will return  back a `payframeToken` and `payframeKey`
- Now, make a call to `/api/merchant-warrior/process-authorization` with the
following body params:
  ```
  {
    "order_uuid": "2369047b-6b94-4b09-8089-d8c0be983dac",
    "merchant_warrior_access_token": "a532c39812",
    "merchant_warrior_payframe_token": "3d29abb98506d3e643e9",
    "merchant_warrior_payframe_key": "9f7e6050a7cfe912ad17389626988df5"
  }
  ```
- This will authorize the payment with MW create an order payment and return
back a 200 with the order ID and UUID
- Place the order in the FE

#### Using the Drupal Backend

- The procedure is the same as with all payment gateways
- Select the Merchant Warrior Payment gateway from the list of available
payment gateways
- Enter your credit card details
- Continue to the payment review process
- Complete the checkout
- This will authorize and capture (depending on whether both are enabled)
the payment for the order total on Merchant Warrior.

## REQUIREMENTS

This module requires the following:

- Submodules of Drupal Commerce package (https://drupal.org/project/commerce)
  - Commerce core
  - Commerce Payment (and its dependencies)
- Merchant Warrior Merchant account

## INSTALLATION

- This module needs to be installed via Composer, which will download
  the required libraries.
  `composer require "drupal/commerce_merchant_warrior"`
  https://www.drupal.org/docs/8/extending-drupal-8/installing-modules-composer-dependencies

## CONFIGURATION

- Create a new Merchant Warrior Payframe payment gateway.
  Administration > Commerce > Configuration > Payment gateways >
  Add payment gateway

## HOW IT WORKS

- General considerations:

  - The store owner must have a Merchant Warrior merchant account.
  - Customers should have a valid credit card.
  - You should enable the required currencies in the MW account.
